﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using KellermanSoftware.WhatsChanged;

namespace Whats_Changed_Demo
{
    public partial class frmWhatsChanged : Form
    {
        public frmWhatsChanged()
        {
            InitializeComponent();
        }

        private void btnOriginal_Click(object sender, EventArgs e)
        {
            if (dlgOpen.ShowDialog(this) == DialogResult.OK)
            {
                txtOriginal.Text = dlgOpen.FileName;
            }
        }

        private void btnChanged_Click(object sender, EventArgs e)
        {
            if (dlgOpen.ShowDialog(this) == DialogResult.OK)
            {
                txtChanged.Text = dlgOpen.FileName;
            }
        }

        private void frmWhatsChanged_Load(object sender, EventArgs e)
        {
            cboOutput.SelectedIndex = cboOutput.FindString("HTML");
        }

        private void btnCompare_Click(object sender, EventArgs e)
        {
            if (String.IsNullOrEmpty(txtOriginal.Text) || String.IsNullOrEmpty(txtChanged.Text))
            {
                MessageBox.Show(this, "Please choose two files to compare");
                return;
            }

            CompareLogic compareLogic = new CompareLogic();
            ComparisonResult result = compareLogic.CompareFiles(txtOriginal.Text, txtChanged.Text);

            OutputDataTableLogic outputDataTableLogic = new OutputDataTableLogic();
            grdResults.DataSource = outputDataTableLogic.OutputToDataTable(result);

            string filePath = null;

            switch (cboOutput.SelectedItem.ToString())
            {
                case "HTML":
                    OutputHtmlLogic htmlLogic = new OutputHtmlLogic();
                    filePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments),
                                                   "differences.html");
                    htmlLogic.OutputToFile(result, filePath);
                    break;
                case "CSV":
                    OutputCsvLogic csvLogic = new OutputCsvLogic();
                    filePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments),
                                                   "differences.csv");
                    csvLogic.OutputToFile(result, filePath);
                    break;
                case "Text":
                    OutputTextLogic textLogic = new OutputTextLogic();
                    filePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments),
                                                   "differences.txt");
                    textLogic.OutputToFile(result, filePath);
                    break;
            }

            if (!string.IsNullOrEmpty(filePath))
            {
                //Show the file in the default viewer
                System.Diagnostics.Process proc = new System.Diagnostics.Process();
                proc.StartInfo.FileName = filePath;
                proc.Start();
            }
        }
    }
}
